//----------------------------------------------------------------------------------
//		DCT2D
//----------------------------------------------------------------------------------
/*
2008/10/11 ver 0.00a
EƂ肠JB
*/

#include <windows.h>
#include "filter.h"

#include "dct_int32.c"		//Ζ؎DCT-iDCT\[X
#include "idct_int32.c"		//Ζ؎DCT-iDCT\[X
#include "idct_clip_table.c"	//Ζ؎DCT-iDCTp\[X


typedef struct {
	int n_shift;
	int shift;
	short Qp[64];
} FILTER_DATA;


//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define	TRACK_N	15								//	gbNo[̐
TCHAR		*track_name[] =		{	"n_shift",	"matrixL1",	"matrixL2",	"matrixL3",	"matrixL4",	"matrixL5",	"matrixL6",	"matrixL7",	"matrixL8",	"matrixL9",	"matrixL10",	"matrixL11",	"matrixL12",	"matrixL13",	"matrixL14",	};	//	gbNo[̖O
int		track_default[] =	{	4,	0,	0,	1,	2,	3,	4,	5,	6,	7,	8,	9,	10,	11,	12,	};	//	gbNo[̏l
int		track_s[] =		{	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	};	//	gbNo[̉l
int		track_e[] =		{	8,	128,	128,	128,	128,	128,	128,	128,	128,	128,	128,	128,	128,	128,	128,	};	//	gbNo[̏l

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,	//	tB^̃tO
	0,0,
	"DCT2D",			//	tB^̖O
	TRACK_N,			//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,			//	gbNo[̖OSւ̃|C^
	track_default,			//	gbNo[̏lSւ̃|C^
	track_s,track_e,		//	gbNo[̐l̉ (NULLȂS0`256)
	NULL,				//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	NULL,				//	`FbN{bNX̖OSւ̃|C^
	NULL,				//	`FbN{bNX̏lSւ̃|C^
	func_proc,			//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,				//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,				//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,				//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,				//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,			//	VXeŎg܂̂ŎgpȂł
	NULL,				//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,				//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"DCT2D ver0.00a",		//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,				//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,				//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}


//---------------------------------------------------------------------
//		֐`
//---------------------------------------------------------------------
void shift_data(int thread_id,int thread_num,void *param1,void *param2);
void Loop( int thread_id,int thread_num,void *param1,void *param2 );


//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	int x, y, flug;
	FILTER_DATA fd;

	fd.n_shift = fp->track[0];

	for( y=0; y<8; y++)
		for( x=0; x<8; x++)
			fd.Qp[x+y*8] = 128-fp->track[x+y];

	flug = 1;
	fp->exfunc->exec_multi_thread_func(shift_data,(void *)fpip, (void *)&flug);

	for( fd.shift=0; fd.shift<fd.n_shift; fd.shift++ )
		fp->exfunc->exec_multi_thread_func( Loop, (void *)fpip, (void *)&fd );

	flug = -1;
	fp->exfunc->exec_multi_thread_func(shift_data,(void *)fpip, (void *)&flug);

	return TRUE;
}


//---------------------------------------------------------------------
//		ff[^Vtg֐
//---------------------------------------------------------------------
void shift_data(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param1;
	int flug = *(int *)param2;

	int x,y;
	PIXEL_YC *ycp;

	int y_start,y_end;
	y_start = ( fpip->h * thread_id     ) / thread_num;
	y_end   = ( fpip->h * (thread_id+1) ) / thread_num;

	if(flug == 1){
		for( y=y_start; y<y_end; y++ ){
			ycp = fpip->ycp_edit + y*fpip->max_w;
			for( x=0; x<fpip->w; x++ ){
				ycp->y   = ycp->y/16;
				ycp->cb  = (ycp->cb>0) ? (ycp->cb+8)/16 : (ycp->cb-8)/16;
				ycp->cr  = (ycp->cr>0) ? (ycp->cr+8)/16 : (ycp->cr-8)/16;
				ycp++;
			}
		}
	}else{
		for( y=y_start; y<y_end; y++ ){
			ycp = fpip->ycp_edit + y*fpip->max_w;
			for( x=0; x<fpip->w; x++ ){
				ycp->y  *= 16;
				ycp->cb *= 16;
				ycp->cr *= 16;
				ycp++;
			}
		}
	}
}


//---------------------------------------------------------------------
//		ڂ֐
//---------------------------------------------------------------------
void Loop( int thread_id,int thread_num,void *param1,void *param2 )
{

	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param1;
	FILTER_DATA fd 			= *(FILTER_DATA *)param2;

	int x, y, xblock, yblock,i;
	PIXEL_YC *ycp;

	int shift_pix = (8 / fd.n_shift * fd.shift);

	int y_start,y_end;
	//	Xbh̉摜ꏊvZ
	y_start = ( fpip->h * thread_id     ) / thread_num + shift_pix+1;
	y_end   = ( fpip->h * (thread_id+1) ) / thread_num;

	int block[64], blockCb[64], blockCr[64];

//0,0炸炵DCT-iDCTȂ̂ŉ摜̒[܂ŏ͂Ȃ
	int h = (y_end == fpip->h ) ? fpip->h -8 : y_end;
	int w = fpip->w -8;

	for( yblock=y_start; yblock<h; yblock+=8 ){
		for( xblock=shift_pix+1; xblock<w; xblock+=8 ){

			i=0;
			for( y=0, ycp = fpip->ycp_edit + yblock*fpip->max_w + xblock; y<8; y++,ycp += fpip->max_w){
				for( x=0; x<8; x++,i++ ){
					block[i]   = ycp[x].y;
					blockCb[i] = ycp[x].cb;
					blockCr[i] = ycp[x].cr;
				}
			}

			dct_int32(block);	//URTCϊ
			dct_int32(blockCb);	//URTCϊ
			dct_int32(blockCr);	//URTCϊ
			for (i=1; i<64; i++){
				block[i]   = block[i]   *fd.Qp[i] /128;
				blockCb[i] = blockCb[i] *fd.Qp[i] /128;
				blockCr[i] = blockCr[i] *fd.Qp[i] /128;
			}
			idct_int32(block);	//tURTCϊ
			idct_int32(blockCb);//tURTCϊ
			idct_int32(blockCr);//tURTCϊ

			i=0;
			for( y=0,ycp = fpip->ycp_edit + yblock*fpip->max_w + xblock; y<8; y++,ycp += fpip->max_w ){
				for( x=0; x<8; x++,i++ ){
					ycp[x].y  = block[i];
					ycp[x].cb = blockCb[i];
					ycp[x].cr = blockCr[i];
				}
			}
		}
	}

}
